drama.shaders = {};
drama.shaders["grayscale"] = {
	src: "varying mediump vec2 vTex;\nuniform lowp sampler2D samplerFront;\nuniform lowp float intensity;\n\nvoid main(void)\n{	lowp vec4 front = texture2D(samplerFront, vTex);	lowp float gray = front.r * 0.299 + front.g * 0.587 + front.b * 0.114;	gl_FragColor = mix(front, vec4(gray, gray, gray, front.a), intensity);\n}\n",
	extendBoxHorizontal: 0,
	extendBoxVertical: 0,
	crossSampling: false,
	preservesOpaqueness: true,
	animated: false,
	parameters: [["intensity",0,1]]
};

drama.shaders["replacecolor"] = {
	src: "varying mediump vec2 vTex;\nuniform lowp sampler2D samplerFront;\nuniform lowp vec3 sourceColor;\nuniform lowp vec3 destColor;\nuniform lowp float tolerance;\n\nvoid main(void)\n{\n	lowp vec4 front = texture2D(samplerFront, vTex);\n	lowp float a = front.a;\n	\n	if (a != 0.0)\n		front.rgb /= a;	lowp float diff = length(front.rgb - sourceColor);\n	\n	if (diff <= tolerance)\n	{\n		front.rgb = mix(front.rgb, destColor, 1.0 - diff / tolerance);\n	}\n	\n	front.rgb *= a;\n	gl_FragColor = front;\n}\n",
	extendBoxHorizontal: 0,
	extendBoxVertical: 0,
	crossSampling: false,
	preservesOpaqueness: true,
	animated: false,
	parameters: [["sourceColor",0,2],["destColor",0,2],["tolerance",0,1]]
};

drama.shaders["warpripple"] = {
	src: "varying mediump vec2 vTex;\nuniform lowp sampler2D samplerFront;\nuniform mediump vec2 srcOriginStart;\nuniform mediump vec2 srcOriginEnd;\nuniform mediump float seconds;\nuniform mediump vec2 pixelSize;\n\nuniform mediump float freq;\nuniform mediump float amp;\nuniform mediump float speed;\n\nconst mediump float PI = 3.1415926;\n\nvoid main(void)\n{\n	mediump vec2 srcOriginSize = srcOriginEnd - srcOriginStart;\n	mediump vec2 tex = (vTex - srcOriginStart) / srcOriginSize;\n	tex = tex * 2.0 - 1.0;\n		\n	mediump float d = length(tex);\n	mediump float a = atan(tex.y, tex.x);\n	\n	d += sin((d * 2.0 * PI) * freq / (pixelSize.x * 750.0) + (seconds * speed)) * amp * (pixelSize.x * 750.0);\n	\n	tex.x = cos(a) * d;\n	tex.y = sin(a) * d;\n	\n	tex = (tex + 1.0) / 2.0;\n	tex = clamp(tex, 0.0, 1.0);\n	tex = tex * srcOriginSize + srcOriginStart;\n	\n	gl_FragColor = texture2D(samplerFront, tex);\n}\n",
	extendBoxHorizontal: 50,
	extendBoxVertical: 50,
	crossSampling: false,
	preservesOpaqueness: false,
	animated: true,
	parameters: [["freq",0,0],["amp",0,1],["speed",0,0]]
};
